



//  Basic Types


fn main() {

    // Primitive types
    let t: bool = true; // boolean – true, false
    let m: i32 = -5; // signed integers – i8, i16, i32, i64, i128
    let n: u64 = 42; // unsigned integers – u8, u16, u32, u64, u128
    let i: isize = 1; // integers with length depending on CPU arch – isize, usize
    let x: f64 = 2_000_000.0; // floating point numbers – f32, f64

    let crab: char = '🦀'; // four bytes Unicode scalar value
    let s: &str = "utf8 string literal 🦀"; // static string

    // Compound types
    let array: [i32; 4] = [1, 3, 7, 8]; // fixed-size arrays of uniform type
    let tuple: (i32, f64, char) = (0, 1., '🦀'); // fixed-size tuple of mixed types
    
    array[0]; // array indexing starts at 0
    (tuple.0, tuple.1); // tuple member access via dot
        
    // Unit type
    let unit: () = (); // tuple with no elements
}
