



//  Functions

// functions with no arguments and no return value
fn hello() -> () {
    println!("Hello, world!");
}

// arguments and return values *must* have type annotations
fn square(x: i32) -> i32 {
    // Last expression in a function is the return value.
    // Take note of the missing semicolon!!
    x*x
}

fn main() -> () { // In fact, the `-> ()` can be omitted as we have seen previously
    // calling a fuction
    hello();

    // functions are first class citizens
    let f = square;
    let cube = |x| {x*x*x};

    println!("4*4 = {}", f(4));
    println!("4*4*4 = {}", cube(4u8));
}

