



//  References and Borrowing


fn multiply(a: &f64, b: &f64) -> f64 {  // `&T` is an immutable reference
    a*b
}

fn multiply_to(a: &mut f64, b: &f64) {  // `&mut T` is a mutable reference
    *a = (*a) * b;   // (*a) is the dereference operation
}

fn main() {
    let mut x: f64 = 3.0;
    let mut y: f64 = 5.0;

    // You can pass a mutable reference where an immutable reference is expected.
    let product1 = multiply(&mut y, &x);
    
    // You can create as many immutable references as you want.
    let product2 = multiply(&x, &x);

    // XOR at most one mutable reference.
    multiply_to(&mut y, &x);

    // ⚡ Compile time error!
    // You *cannot* have a mutable and immutable reference
    multiply_to(&mut y, &y);
    // You *cannot* have two mutable references
    multiply_to(&mut y, &mut y);

}
