



//  Enums and the Match Expression

enum Color{
    Black,
    White,
    RGB(u8, u8, u8),  // Enum variants can hold arbitrary data, in this case a tuple
}

fn what_color(c: &Color) {
 
    let g: u8 = match c { // match expression is exhaustive
        Color::RGB(0, 0, 0) => {
            println!("Deepest black."); 0
        }
        Color::Black => {
            println!("Deepest black."); 0
        }
        Color::White | Color::RGB(255, 255, 255) => { // expression matching can be very elegant
            println!("Purest white."); 255
        }
        Color::RGB(_, g,_) => { *g } // expression matching can also grant access to internal data
    };
    println!("Color with green value {}.", g);
}

fn main() {
    let c1 = Color::RGB(255, 255, 255);
    let c2 = Color::RGB(128, 128, 255);
    what_color(&c1);
    what_color(&c2);
}
