



// There is no Null


fn main() {

    // Absense of value is represented with the enum Option<T> from the std library.
    // Its variants are Some(T) and None. Often used as return type from functions.
    
    let maybe_one: Option<f64> = Some(1.0);
    let maybe_two: Option<f64> = None;

    match (maybe_one, maybe_two) {  // match is always exhaustive and throws compile time errors 
        (Some(a), Some(b)) => {     // if you forget to cover any case
            println!("{}", a*b);
        },
        _ => {  // catchall pattern for other cases: (None, Some(_)), (Some(_), None), (None, None)
            println!("Absense of value detected!");
        },
    }

    if let Some(a) = maybe_one { // `if let` is a concise way to cover exactly one case
        println!("variable carries the value {}", a);
    }

}
