



//  Iterators


//  Σ_i {i²}

fn sum_of_squares(n: u64) -> u64 {
    n * (n + 1) * (2 * n + 1) / 6
}

fn main() { // Iterator manipulation compiles down to equivalent for loops.
            // Advantage: you don't need to handle the internal mutable variables.
    let n: u64 = 1_000_000;
    let s: u64 = (1..=n)
    	.map(|x| x * x)
    	.sum();

    println!("{} – {}", s, sum_of_squares(n));
    
    let v1 = vec![1.0, 2.0, 3.0];
    let v2 = vec![5.0, 6.0, 7.0];

    let scalar_product: f64 = v1.iter() // You can iterate over many collection types
        .zip(v2)
        .map(|(x, y)| {x*y})
        .sum();
}
