



//  Easy Data Parallelism with Rayon


use rayon::prelude::*;

fn sum_of_squares(n: u64) -> u64 {
    n * (n + 1) * (2 * n + 1) / 6
}

fn main() {  // Here we use parallel iterators from the `rayon` crate
             // Our source code looks the same, but rayon handles the task with a thread pool
    let n: u64 = 1_000_000;
    let s: u64 = (1..=n).into_par_iter()
        .map(|x| x * x)
        .sum();
        
    println!("{} – {}", s, sum_of_squares(n));

	let v1 = vec![1.0, 2.0, 3.0];
    let v2 = vec![5.0, 6.0, 7.0];

    let scalar_product: f64 = v1.par_iter()
        .zip(v2)
        .map(|(x, y)| {x*y})
        .sum();
}
