



// Shared Mutable State


use std::thread;

// ⚡ Compile time error!
// This code will not compile!
fn main() {

    let mut state: u64 = 0;

    let state_ref = &mut state;

    let handle1 = thread::spawn(move || { // The move keyword tries to explicitly capture variables
        *state_ref += 1;                  // from the environment, creating a true Closure
    });

    let handle2 = thread::spawn(move || {
        *state_ref += 1;
    });  // But you cannot get this code to compile when trying to grant
         // shared mutable access to `state`. Even trying to wrap it into Rc<T> or RefCell<T>
         // will fail. Those are not thread safe.
    handle1.join().unwrap();
    handle2.join().unwrap();

    println!("{}", state);
}
