



//  Channels for message passing between threads


use std::sync::mpsc;
use std::thread;

fn main() {

	// Multiple Producer Single Consumer channel with transmittter tx and receiver rx
    let (tx, rx) = mpsc::channel();

    let tx1 = tx.clone(); // we can clone the transmitter to create multiple producers
    thread::spawn(move || { // here we move ownership of the transmitter tx1 into the thread
        let vals = vec![ 1, 3, 5, 7, 9 ];

        for val in vals {
            tx1.send(val).unwrap(); // tx.send(val) is a call-by-value and moves ownership!
        }
    });
    thread::spawn(move || { // here we move ownership of the original transmitter tx 
        let vals = vec![ 2, 4, 6, 8, 10 ];

        for val in vals {
            tx.send(val).unwrap();
        }
    });

    for received in rx { // main thread holds onto the receiver and loops over incoming values
        println!("Got: {}", received);
    }
}
